/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalytics4ConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalytics4ConnectorFormAllOf{}

// GoogleAnalytics4ConnectorFormAllOf struct for GoogleAnalytics4ConnectorFormAllOf
type GoogleAnalytics4ConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Google Analytics 4 Account ID.
	AccountId *string `json:"accountId,omitempty"`
	// Google Analytics 4 Property ID.
	PropertyId *string `json:"propertyId,omitempty"`
	// Google Analytics 4 Property ID.
	PropertyIds []interface{} `json:"propertyIds,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
	// Metric
	Metric []string `json:"metric,omitempty"`
	// Dimensions
	Dimension []string `json:"dimension,omitempty"`
	// Limit
	Limit *int32 `json:"limit,omitempty"`
}

// NewGoogleAnalytics4ConnectorFormAllOf instantiates a new GoogleAnalytics4ConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalytics4ConnectorFormAllOf() *GoogleAnalytics4ConnectorFormAllOf {
	this := GoogleAnalytics4ConnectorFormAllOf{}
	var limit int32 = 10000
	this.Limit = &limit
	return &this
}

// NewGoogleAnalytics4ConnectorFormAllOfWithDefaults instantiates a new GoogleAnalytics4ConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalytics4ConnectorFormAllOfWithDefaults() *GoogleAnalytics4ConnectorFormAllOf {
	this := GoogleAnalytics4ConnectorFormAllOf{}
	var limit int32 = 10000
	this.Limit = &limit
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetAccountId(v string) {
	o.AccountId = &v
}

// GetPropertyId returns the PropertyId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetPropertyId() string {
	if o == nil || IsNil(o.PropertyId) {
		var ret string
		return ret
	}
	return *o.PropertyId
}

// GetPropertyIdOk returns a tuple with the PropertyId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetPropertyIdOk() (*string, bool) {
	if o == nil || IsNil(o.PropertyId) {
		return nil, false
	}
	return o.PropertyId, true
}

// HasPropertyId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasPropertyId() bool {
	if o != nil && !IsNil(o.PropertyId) {
		return true
	}

	return false
}

// SetPropertyId gets a reference to the given string and assigns it to the PropertyId field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetPropertyId(v string) {
	o.PropertyId = &v
}

// GetPropertyIds returns the PropertyIds field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetPropertyIds() []interface{} {
	if o == nil || IsNil(o.PropertyIds) {
		var ret []interface{}
		return ret
	}
	return o.PropertyIds
}

// GetPropertyIdsOk returns a tuple with the PropertyIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetPropertyIdsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.PropertyIds) {
		return nil, false
	}
	return o.PropertyIds, true
}

// HasPropertyIds returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasPropertyIds() bool {
	if o != nil && !IsNil(o.PropertyIds) {
		return true
	}

	return false
}

// SetPropertyIds gets a reference to the given []interface{} and assigns it to the PropertyIds field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetPropertyIds(v []interface{}) {
	o.PropertyIds = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDimension returns the Dimension field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetDimension() []string {
	if o == nil || IsNil(o.Dimension) {
		var ret []string
		return ret
	}
	return o.Dimension
}

// GetDimensionOk returns a tuple with the Dimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetDimensionOk() ([]string, bool) {
	if o == nil || IsNil(o.Dimension) {
		return nil, false
	}
	return o.Dimension, true
}

// HasDimension returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasDimension() bool {
	if o != nil && !IsNil(o.Dimension) {
		return true
	}

	return false
}

// SetDimension gets a reference to the given []string and assigns it to the Dimension field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetDimension(v []string) {
	o.Dimension = v
}

// GetLimit returns the Limit field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetLimit() int32 {
	if o == nil || IsNil(o.Limit) {
		var ret int32
		return ret
	}
	return *o.Limit
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) GetLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.Limit) {
		return nil, false
	}
	return o.Limit, true
}

// HasLimit returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorFormAllOf) HasLimit() bool {
	if o != nil && !IsNil(o.Limit) {
		return true
	}

	return false
}

// SetLimit gets a reference to the given int32 and assigns it to the Limit field.
func (o *GoogleAnalytics4ConnectorFormAllOf) SetLimit(v int32) {
	o.Limit = &v
}

func (o GoogleAnalytics4ConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalytics4ConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.PropertyId) {
		toSerialize["propertyId"] = o.PropertyId
	}
	if !IsNil(o.PropertyIds) {
		toSerialize["propertyIds"] = o.PropertyIds
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.Dimension) {
		toSerialize["dimension"] = o.Dimension
	}
	if !IsNil(o.Limit) {
		toSerialize["limit"] = o.Limit
	}
	return toSerialize, nil
}

type NullableGoogleAnalytics4ConnectorFormAllOf struct {
	value *GoogleAnalytics4ConnectorFormAllOf
	isSet bool
}

func (v NullableGoogleAnalytics4ConnectorFormAllOf) Get() *GoogleAnalytics4ConnectorFormAllOf {
	return v.value
}

func (v *NullableGoogleAnalytics4ConnectorFormAllOf) Set(val *GoogleAnalytics4ConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalytics4ConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalytics4ConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalytics4ConnectorFormAllOf(val *GoogleAnalytics4ConnectorFormAllOf) *NullableGoogleAnalytics4ConnectorFormAllOf {
	return &NullableGoogleAnalytics4ConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableGoogleAnalytics4ConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalytics4ConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
